package com.june.entitytodbdoc;

import com.june.entitytodbdoc.dto.DocumentInfoDTO;
import com.june.entitytodbdoc.utils.FileUtils;
import com.june.entitytodbdoc.utils.GetClassCommentUtils;
import com.june.entitytodbdoc.utils.MarkdownUtils;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 开始解析文档注释启动类
 *
 * @author june
 */
public class Starter {

    public static final String PRE_PATH = "D:\\work\\idea\\june\\entity-to-db-doc\\";

    /**
     * 忽略的表列表
     */
    private static final List<String> IGNORE_DOCUMENT_NAMES = Arrays.asList(
            "v4.food.material",
            "v4.food.package",
            "v4.food.process",
            "v3.question.answers",
            "v3.knowledge.question",
            "v3.article.library",
            "v3.questionnaire.question",
            "v3.exercise",
            "v3.video.rest",
            "v4.exercise.modern.action"
    );

    public static void main(String[] args) {
        String beanFilePath =
                PRE_PATH + "\\entity-to-db-doc\\src\\main\\java\\com\\jiankangyouyi\\cloud";
        List<String> javaFilePaths = FileUtils.findJavaFilePaths(beanFilePath);
        // List<String> javaFilePaths = Arrays.asList(PRE_PATH + "\\entity-to-db-doc\\src\\main\\java\\com\\jiankangyouyi\\cloud\\motorplan\\model\\entity\\mongo\\ExerciseCourseProjectGlobalConfigDO.java");
        // 获取所有的 markdown 内容
        List<String> resultContentList = javaFilePaths
                .parallelStream().map(GetClassCommentUtils::execute)
                .filter(Optional::isPresent)
                .map(Optional::get)
                .filter(dto -> !IGNORE_DOCUMENT_NAMES.contains(dto.getDocumentName()))
                .distinct()
                .sorted(Comparator.comparing(DocumentInfoDTO::getDocumentName))
                .map(MarkdownUtils::getOneDocumentContent)
                .flatMap(Collection::stream)
                .collect(Collectors.toList());
        String path = PRE_PATH + "\\entity-to-db-doc\\src\\main\\java\\com\\june\\entitytodbdoc\\xx.md";
        FileUtils.writeMarkdown(resultContentList, path);
    }


}
